#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;

struct edge {
	int u, v;
	long long s, w;
	
	edge() {}
};

struct query {
	long long a, b;
	int i;
	
	query() {}
	
	bool operator<(const query& q) const {
		return a * q.b < b * q.a;
	}
};

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	
	vector <edge> e(m);
	for (int i = 0; i < m; i++)
		cin >> e[i].u >> e[i].v >> e[i].s >> e[i].w;
	
	vector <query> t(q);
	for (int i = 0; i < q; i++)
		t[i].i = i, cin >> t[i].a >> t[i].b;
	
	sort(t.begin(), t.end());
	
	int l = -1, r = q;
	while (r - l > 1) {
		int d = (l + r) / 2;
		if (d == -1) break;
		if (d == q) break;
		vector <vector <int>> g(n);
		for (int i = 0; i < m; i++)
			if (e[i].w * t[d].b < e[i].s * t[d].a)
				g[e[i].u - 1].push_back(e[i].v - 1);
		
		vector <char> used(n);
		function <void(int)> dfs = [&](int v) {
			used[v] = 1;
			for (auto to : g[v])
				if (!used[to])
					dfs(to);
		};
		
		dfs(0);
		
		if (used[n - 1]) r = d;
		else l = d;
	}
	
	vector <bool> ans(q);
	for (int i = 0; i < q; i++)
		ans[t[i].i] = (i > l);
	
	for (int i = 0; i < q; i++)
		cout << (ans[i] ? "YES\n" : "NO\n");
	
	return 0;
}